#ifndef SIM_MAIN_H
#define SIM_MAIN_H

#include "sim-basics.h"

typedef address_word sim_cia;

#include "sim-base.h"

typedef unsigned64 reg_t;

struct _sim_cpu
{
   /* ... simulator specific members ... */
   reg_t regs[256];
   reg_t pc;

   /* ... base type ... */
   sim_cpu_base base;
};

struct sim_state
{
   sim_cpu cpu[MAX_NR_PROCESSORS];
   /* ... simulator specific members ... */

   /* ... base type ... */
   sim_state_base base;
};

#if (WITH_SMP)
#define STATE_CPU(sd,n) (&(sd)->cpu[n])
#else
#define STATE_CPU(sd,n) (&(sd)->cpu[0])
#endif

/* For compatibility, until all functions converted to passing
   SIM_DESC as an argument */
extern SIM_DESC simulator;

#define CIA_GET(CPU) ((CPU)->pc + 0)
#define CIA_SET(CPU,VAL) ((CPU)->pc = (VAL))

#define GPR_SET(N, VAL) (STATE_CPU(simulator, 0)->regs[(N)] = (VAL))
#define GPR_CLEAR(N)    (STATE_CPU(simulator, 0)->regs[(N)] = 0)

#define IMEM32(EA) \
sim_core_read_4 (CPU, (CPU)->pc, exec_map, (EA))

#endif
